/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.ai;

import com.sk89q.worldedit.extent.clipboard.Clipboard;
import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.fight.FightTeam;
import de.steamwar.fightsystem.states.FightState;
import de.steamwar.fightsystem.utils.FightStatistics;
import de.steamwar.sql.SchematicNode;
import de.steamwar.sql.SteamwarUser;

import java.util.List;
import java.util.Random;

public class DummyAI extends AI {

    private static final Random random = new Random();

    public DummyAI(FightTeam team) {
        super(team, SteamwarUser.get("public"));

        FightStatistics.unrank();
        getEntity().setInvulnerable(true);
    }

    @Override
    public SchematicNode chooseSchematic() {
        List<SchematicNode> publics = SchematicNode.getAllSchematicsOfType(0, Config.SchematicType.toDB());
        return publics.get(random.nextInt(publics.size()));
    }

    @Override
    public void schematic(Clipboard clipboard) {
        //does nothing
    }

    @Override
    protected void plan() {
        if(FightState.getFightState() == FightState.POST_SCHEM_SETUP)
            setReady();
    }
}
